// "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
// Ken Silverman's official web site: "http://www.advsys.net/ken"
// See the included license file "BUILDLIC.TXT" for license info.

#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include "build.h"
#include "pragmas.h"

// #include "names.h"
#include <dos.h>
#include <stdio.h>

extern char keystatus[256];
extern char names[MAXTILES][17];

static char tempbuf[256];
static char tempbuf2[256];
static char tempbuf3[256];
char kensig[42];
char versionum[5];
char getmessage[162];
char tempval[80];
long val;
extern char getmessageleng;
long getmessagetimeoff, autosavetimeoff, nosetup;
long fpsoffset;
extern long qsetmode;
extern long hvel;
extern long zlock;
extern short searchsector, searchwall, searchstat;
extern short asksave, mapnumber;
extern long kensplayerheight, whitecol;
extern short defaultspritecstat;
extern short curmenuchoice;
extern short temppicnum, tempcstat, templotag, temphitag, tempextra;
extern char tempshade, temppal, tempvis, tempxrepeat, tempyrepeat;
char automapname[13];

extern short temppicnum, tempcstat, templotag, temphitag, tempextra;
extern char tempshade, temppal, tempxrepeat, tempyrepeat;
extern char somethingintab;
extern short fpson, helpon, showclipon;
short commaeleven = 7, commaseven = 1, showclippic = 1;
long zmode = 2;
short crap;
short fnord;
#define NUMOPTIONS 8
#define NUMKEYS 19
static long vesares[13][2] = {320,200,360,200,320,240,360,240,320,400,
									360,400,640,350,640,400,640,480,800,600,
									1024,768,1280,1024,1600,1200};

static long digihz[7] = {6000,8000,11025,16000,22050,32000,44100};
static char option[NUMOPTIONS] = {0,0,0,0,0,0,1,0};
static char keys[NUMKEYS] =
{
	0xc8,0xd0,0xcb,0xcd,0x2a,0x9d,0x1d,0x39,
	0x1e,0x2c,0xd1,0xc9,0x33,0x34,
        0x9c,0x1c,0xd,0xc,0xf,
};

extern char buildkeys[NUMKEYS];

extern long frameplace, xdimenscale, ydimen;
extern long posx, posy, posz, horiz;
extern short ang, cursectnum;

static long hang = 0;
extern long stretchhline(long,long,long,long,long,long);
#pragma aux stretchhline parm [eax][ebx][ecx][edx][esi][edi];

//Detecting 2D / 3D mode:
//   qsetmode is 200 in 3D mode
//   qsetmode is 350/480 in 2D mode
//
//You can read these variables when F5-F8 is pressed in 3D mode only:
//
//   If (searchstat == 0)  WALL        searchsector=sector, searchwall=wall
//   If (searchstat == 1)  CEILING     searchsector=sector
//   If (searchstat == 2)  FLOOR       searchsector=sector
//   If (searchstat == 3)  SPRITE      searchsector=sector, searchwall=sprite
//   If (searchstat == 4)  MASKED WALL searchsector=sector, searchwall=wall
//
//   searchsector is the sector of the selected item for all 5 searchstat's
//
//   searchwall is undefined if searchstat is 1 or 2
//   searchwall is the wall if searchstat = 0 or 4
//   searchwall is the sprite if searchstat = 3 (Yeah, I know - it says wall,
//                                      but trust me, it's the sprite number)

long ofinetotalclock, ototalclock, averagefps;
#define AVERAGEFRAMES 32
static long frameval[AVERAGEFRAMES], framecnt = 0;

#pragma aux inittimer42 =\
	"in al, 0x61",\
	"or al, 1",\
	"out 0x61, al",\
	"mov al, 0xb4",\
	"out 0x43, al",\
	"xor al, al",\
	"out 0x42, al",\
	"out 0x42, al",\
	modify exact [eax]\

#pragma aux uninittimer42 =\
	"in al, 0x61",\
	"and al, 252",\
	"out 0x61, al",\
	modify exact [eax]\

#pragma aux gettimer42 =\
	"mov al, 0x84",\
	"out 0x43, al",\
	"in al, 0x42",\
	"shl eax, 24",\
	"in al, 0x42",\
	"rol eax, 8",\
	modify [eax]\


void idsound(int freq, int dly)
{
	sound(freq);
	delay(dly);
	nosound();
}

void ExtSaveMap(const char *mapname)
{


}






void ExtInit(void)
{
        long i,j,k,l, fil;
        long pos, null=0;
        char string[80];
        FILE *in;
        FILE *sc;
        int             ix;
	FILE	   *f;
	char	   def[80];
	char		strparm[50];
	int		parm;

        


        strcpy(kensig,"Mapster 0.40");
	/*printf("------------------------------------------------------------------------------\n");
	printf("   BUILD.EXE copyright(c) 1996 by Ken Silverman.  You are granted the\n");
	printf("   right to use this software for your personal use only.  This is a\n");
	printf("   special version to be used with \"Happy Fun KenBuild\" and may not work\n");
	printf("   properly with other Build engine games.  Please refer to license.doc\n");
	printf("   for distribution rights\n");
	printf("------------------------------------------------------------------------------\n");
	getch();
	*/




        printf("\n%s\n",kensig);
        initgroupfile("stuff.dat");
        initgroupfile("duke3d.grp");






        if ((fil = open("setup.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&option[0],NUMOPTIONS);
		read(fil,&keys[0],NUMKEYS);
		memcpy((void *)buildkeys,(void *)keys,NUMKEYS);   //Trick to make build use setup.dat keys
		close(fil);
	}
        else
        {
        nosetup = 1;
        }
        if (option[4] > 0) option[4] = 0;
	initmouse();
	initengine();
        if (nosetup != 1)
        {
        vidoption = option[0]; xdim = vesares[option[6]&15][0]; ydim = vesares[option[6]&15][1];
        }
        else
        {
        vidoption = 2; xdim = 320; ydim = 200;
        }
//        initsb(option[1],option[2],digihz[option[7]>>4],((option[7]&4)>0)+1,((option[7]&2)>0)+1,60,option[7]&1);
//        loadsong("quiksong.kdm");
//        musicon();

        	//You can load your own palette lookup tables here if you just
		//copy the right code!
//        for(i=0;i<256;i++)
//                tempbuf[i] = ((i+32)&255);  //remap colors for screwy palette sectors
//        makepalookup(16,tempbuf,0,0,0,1);
        in=fopen("lookup.dat","rb");
        i=fgetc(in);
        for(k=0;k<i;k++)
        {
        j=fgetc(in);
        fread(&tempbuf,256,1,in);
        makepalookup(j,tempbuf,0,0,0,1);
        }
        fclose(in);





        kensplayerheight = 42;
        zmode = 2;
	defaultspritecstat = 0;
	pskyoff[0] = 0; pskyoff[1] = 0; pskybits = 1;
//        wsay("getstuff.wav",4096L,63L,63L);
        autosavetimeoff = totalclock+120*30;
}



void ExtUnInit(void)
{
	uninittimer42();
	uninitgroupfile();
//        uninitsb();
        setvmode(0x3);        //Set back to text mode
}

static long daviewingrange, daaspect, horizval1, horizval2;
void ExtPreCheckKeys(void)
{
        long cosang, sinang, dx, dy, mindx, i;


        if (keystatus[0x3e])  //F4 - screen re-size
	{
		keystatus[0x3e] = 0;

			//cycle through all vesa modes, then screen-buffer mode
		getvalidvesamodes();
		if (vidoption == 1)
		{
                        for(i=0;i<validmodecnt;i++)
                        

                        	if ((validmodexdim[i] == xdim) && (validmodeydim[i] == ydim))
				{
					if (i == validmodecnt-1)
						setgamemode(2,320L,200L);
					else
						setgamemode(1,validmodexdim[i+1],validmodeydim[i+1]);
					break;
				}
		}
		else if (validmodecnt > 0)
			setgamemode(1,validmodexdim[0],validmodeydim[0]);
		sprintf(getmessage,"Video mode: %ld x %ld",xdim,ydim);
		if (vidoption == 2) strcat(getmessage," (Screen-buffer)");
		getmessageleng = strlen(getmessage);
		getmessagetimeoff = totalclock+120*5;

                inittimer42();  //Must init here because VESA 0x4F02 messes timer 2
	}


        if (keystatus[0x29]) { horiz = 100; }

        if (keystatus[0x22]) { if (keystatus[0x28]) {
                                                      if (showclippic == 2) showclippic = 0;
                                                      else if (showclippic == 1) showclippic = 2;
                                                      else if (showclippic == 0) showclippic = 1;
                                                      keystatus[0x22] = 0;
                                                      sprintf(getmessage,"Show clipboard pic: %ld",showclippic);
                                                      } }
        if (totalclock > autosavetimeoff)
             {
             autosavemap("autoxxxx.map");
             if (qsetmode == 200)
             {

             mapnumber--;
             sprintf(automapname,"AUTOXXXX.MAP");
             automapname[4] = ((mapnumber/1000)%10)+48;
             automapname[5] = ((mapnumber/100)%10)+48;
             automapname[6] = ((mapnumber/10)%10)+48;
             automapname[7] = (mapnumber%10)+48;
             mapnumber++;
             sprintf(getmessage,"Map autosaved to %s",automapname);

             getmessageleng = strlen(getmessage);
             getmessagetimeoff = totalclock+120*5;

             }
             else
             {


             }
             autosavetimeoff = totalclock+120*60;

             }
}

#define MAXVOXMIPS 5
extern char *voxoff[][MAXVOXMIPS];
void ExtAnalyzeSprites(void)
{
	long i, *longptr;
	spritetype *tspr;

	for(i=0,tspr=&tsprite[0];i<spritesortcnt;i++,tspr++)
	{
/*
		tspr->shade += 6;
		if (sector[tspr->sectnum].ceilingstat&1)
			tspr->shade += sector[tspr->sectnum].ceilingshade;
		else
			tspr->shade += sector[tspr->sectnum].floorshade;
*/
	}
}

static char timerinited = 0;
void ExtCheckKeys(void)
{
        long i, j, p, y, dx, dy, cosang, sinang, bufplc, tsizy, tsizyup15;
        long charsperline;
        short mousz;
        long goalz, hihit, lohit, hiz, loz;
        short bad;

	if (qsetmode == 200)    //In 3D mode
	{

	if (getmessageleng > 0)
	{
		charsperline = 40;
		//if (dimensionmode[snum] == 2) charsperline = 80;

		for(i=0;i<=getmessageleng;i+=charsperline)
		{
			for(j=0;j<charsperline;j++)
				tempbuf[j] = getmessage[i+j];
			if (getmessageleng < i+charsperline)
				tempbuf[(getmessageleng-i)] = 0;
			else
				tempbuf[charsperline] = 0;

//                        printext256(0L,((i/charsperline)<<3)+(ydim-32-8)-(((getmessageleng-1)/charsperline)<<3),31,-1,tempbuf,0);
                        printext256(0L,20L,31,-1,tempbuf,0);
		}
		if (totalclock > getmessagetimeoff)
			getmessageleng = 0;
	}


        getzrange(posx,posy,posz,cursectnum,&hiz,&hihit,&loz,&lohit,128L,CLIPMASK0);
	if (keystatus[0x3a] > 0)
	{
		zmode++;
		if (zmode == 3) zmode = 0;
		if (zmode == 1) zlock = (loz-posz)&0xfffffc00;
		keystatus[0x3a] = 0;
                if (zmode == 0) sprintf(getmessage,"Zmode = Gravity");
                else if (zmode == 2) sprintf(getmessage,"Zmode = Locked/Free");
                else if (zmode == 1) sprintf(getmessage,"Zmode = Locked/Sector");

                getmessageleng = strlen(getmessage);
		getmessagetimeoff = totalclock+120*5;



        }

	if (zmode == 0)
	{
		goalz = loz-(kensplayerheight<<8);   //playerheight pixels above floor
		if (goalz < hiz+(16<<8))   //ceiling&floor too close
			goalz = ((loz+hiz)>>1);
		goalz += mousz;

		if (keystatus[buildkeys[8]] > 0)                            //A (stand high)
		{
			if (keystatus[0x1d] > 0)
				horiz = max(-100,horiz-((keystatus[buildkeys[4]]+1)<<2));
			else
			{
				goalz -= (16<<8);
				if (keystatus[buildkeys[4]] > 0)    //Either shift key
					goalz -= (24<<8);
			}
		}
		if (keystatus[buildkeys[9]] > 0)                            //Z (stand low)
		{
			if (keystatus[0x1d] > 0)
				horiz = min(300,horiz+((keystatus[buildkeys[4]]+1)<<2));
			else
			{
				goalz += (12<<8);
				if (keystatus[buildkeys[4]] > 0)    //Either shift key
					goalz += (12<<8);
			}
		}

		if (goalz != posz)
		{
			if (posz < goalz) hvel += 32;
			if (posz > goalz) hvel = ((goalz-posz)>>3);

			posz += hvel;
			if (posz > loz-(4<<8)) posz = loz-(4<<8), hvel = 0;
			if (posz < hiz+(4<<8)) posz = hiz+(4<<8), hvel = 0;
		}
	}
	else
	{
		goalz = posz;
		if (keystatus[buildkeys[8]] > 0)                            //A
		{
			if (keystatus[0x1d] > 0)
				horiz = max(-100,horiz-((keystatus[buildkeys[4]]+1)<<2));
			else
			{
				if (zmode != 1)
					goalz -= (8<<8);
				else
				{
					zlock += (4<<8);
					keystatus[buildkeys[8]] = 0;
				}
			}
		}
		if (keystatus[buildkeys[9]] > 0)                            //Z (stand low)
		{
			if (keystatus[0x1d] > 0)
				horiz = min(300,horiz+((keystatus[buildkeys[4]]+1)<<2));
			else
			{
				if (zmode != 1)
					goalz += (8<<8);
				else if (zlock > 0)
				{
					zlock -= (4<<8);
					keystatus[buildkeys[9]] = 0;
				}
			}
		}

		if (goalz < hiz+(4<<8)) goalz = hiz+(4<<8);
		if (goalz > loz-(4<<8)) goalz = loz-(4<<8);
		if (zmode == 1) goalz = loz-zlock;
		if (goalz < hiz+(4<<8)) goalz = ((loz+hiz)>>1);  //ceiling&floor too close
		if (zmode == 1) posz = goalz;

		if (goalz != posz)
		{
			if (posz < goalz) hvel += (32<<keystatus[buildkeys[4]]);
			if (posz > goalz) hvel -= (32<<keystatus[buildkeys[4]]);

			posz += hvel;

			if (posz > loz-(4<<8)) posz = loz-(4<<8), hvel = 0;
			if (posz < hiz+(4<<8)) posz = hiz+(4<<8), hvel = 0;
		}
		else
			hvel = 0;
	}


                    if (showclipon == 1)
                    {
                    if (showclippic == 1 ) { rotatesprite(36<<-16,128<<-16,32768,0,temppicnum,tempshade,temppal,2,0L,0L,xdim-1L,ydim-1L); }
                    else if (showclippic == 2 ) { rotatesprite(36<<-16,128<<-16,16384,0,temppicnum,tempshade,temppal,2,0L,0L,xdim-1L,ydim-1L); }
                    printext256(15,147,31,-1,"CLIPBOARD",1);
                    sprintf(tempbuf,"PICNUM: %ld",temppicnum);
                    printext256(15,156,31,-1,tempbuf,1);
                    sprintf(tempbuf,"SHADE: %ld",tempshade);
                    printext256(15,163,31,-1,tempbuf,1);
                    sprintf(tempbuf,"PAL: %ld",temppal);
                    printext256(15,170,31,-1,tempbuf,1);
                    sprintf(tempbuf,"CSTAT: %ld",tempcstat);
                    printext256(15,177,31,-1,tempbuf,1);
                    sprintf(tempbuf,"LOTAG: %ld",templotag);
                    printext256(15,184,31,-1,tempbuf,1);
                    sprintf(tempbuf,"HITAG: %ld",temphitag);
                    printext256(15,191,31,-1,tempbuf,1);
//                    printext256((xdim>>2)-(strlen(tempbuf)<<2),(ydim>>2),31,-1,tempbuf,1);


                    }



                    if (helpon == 1)
                    {
                    sprintf(tempbuf,"MAPSTER 3D MODE KEY HELP");
                    printext256(5L,18L,31,-1,tempbuf,2);
                    sprintf(tempbuf,"F1 = THIS HELP SCREEN");
                    printext256(5L,27L,31,-1,tempbuf,2);
                    sprintf(tempbuf,"F2 = TOGGLE SHOW CLIPBOARD");
                    printext256(5L,34L,31,-1,tempbuf,2);


                    sprintf(tempbuf,"' S = SHADE OBJECT");
                    printext256(5L,41L,31,-1,tempbuf,2);
                    sprintf(tempbuf,"' T = OBJECT LOTAG");
                    printext256(5L,48L,31,-1,tempbuf,2);
                    sprintf(tempbuf,"' H = OBJECT HITAG");
                    printext256(5L,55L,31,-1,tempbuf,2);
                    sprintf(tempbuf,"' D = SPRITE CLIPDIST");
                    printext256(5L,62L,31,-1,tempbuf,2);
                    sprintf(tempbuf,"' V = SECTOR VISIBILITY");
                    printext256(5L,69L,31,-1,tempbuf,2);
                    sprintf(tempbuf,"' R = FRAMERATE TOGGLE");
                    printext256(5L,76L,31,-1,tempbuf,2);
                    sprintf(tempbuf,"' L = OBJECT LOCATION");
                    printext256(5L,83L,31,-1,tempbuf,2);
                    sprintf(tempbuf,"' ENTER = PASTE GRAPHIC ONLY");
                    printext256(5L,90L,31,-1,tempbuf,2);
                    sprintf(tempbuf,"ALT C = GLOBAL OBJECT CHANGE");
                    printext256(5L,97L,31,-1,tempbuf,2);
                    sprintf(tempbuf,"HOME = PGUP/PGDN MODIFIER (256 UNITS)");
                    printext256(5L,104L,31,-1,tempbuf,2);
                    sprintf(tempbuf,"END = PGUP/PGDN MODIFIER (512 UNITS)");
                    printext256(5L,111L,31,-1,tempbuf,2);

                    // SECOND COLUMN
                    sprintf(tempbuf,"' G = CLIPBOARD GRAPHIC MODE");
                    printext256(130L,34L,31,-1,tempbuf,2);





                    }
                        if ((keystatus[0x26]) > 0)
			{
				switch (searchstat)
				{


                                        case 1:
                                                strcpy(tempbuf,"Sector ceilingz: ");
                                                sector[searchsector].ceilingz = getnumber256(tempbuf,(long)sector[searchsector].ceilingz,8388608);
                                                break;
                                        case 2:
                                                strcpy(tempbuf,"Sector floorz: ");
                                                sector[searchsector].floorz = getnumber256(tempbuf,(long)sector[searchsector].floorz,8388608);
                                                break;

                                        case 3:

                                                strcpy(tempbuf,"Sprite x: ");
                                                sprite[searchwall].x = getnumber256(tempbuf,(long)sprite[searchwall].x,262144L);
                                                strcpy(tempbuf,"Sprite y: ");
                                                sprite[searchwall].y = getnumber256(tempbuf,(long)sprite[searchwall].y,262144L);
                                                strcpy(tempbuf,"Sprite z: ");
                                                sprite[searchwall].z = getnumber256(tempbuf,(long)sprite[searchwall].z,8388608);
                                                strcpy(tempbuf,"Sprite angle: ");
                                                sprite[searchwall].ang = getnumber256(tempbuf,(long)sprite[searchwall].ang,2048L);

						break;
				}
                        
                        keystatus[0x26] = 0;
		}

/*
                if (keystatus[0xa]) setaspect(viewingrange+(viewingrange>>8),yxaspect+(yxaspect>>8));
		if (keystatus[0xb]) setaspect(viewingrange-(viewingrange>>8),yxaspect-(yxaspect>>8));
		if (keystatus[0xc]) setaspect(viewingrange,yxaspect-(yxaspect>>8));
		if (keystatus[0xd]) setaspect(viewingrange,yxaspect+(yxaspect>>8));
*/
		if (!timerinited)
		{
			timerinited = 1;
			inittimer42();  //Must init here because VESA 0x4F02 messes timer 2
		}
		i = totalclock-ototalclock; ototalclock += i;
		j = ofinetotalclock-gettimer42(); ofinetotalclock -= j;
		i = ((i*(1193181/120)-(j&65535)+32768)&0xffff0000)+(j&65535);
		if (i) { frameval[framecnt&(AVERAGEFRAMES-1)] = 11931810/i; framecnt++; }
			//Print MAX FRAME RATE
		i = frameval[(framecnt-1)&(AVERAGEFRAMES-1)];
		for(j=AVERAGEFRAMES-1;j>0;j--) i = max(i,frameval[j]);
		averagefps = ((averagefps*3+i)>>2);
                
                if (fpson == 1)
                  {
                    sprintf(tempbuf,"%ld.%ld",averagefps/10 - fpsoffset,averagefps%10);
                    printext256(0L,0L,31,-1,tempbuf,1);
                  }
             



                editinput();
	}
	else
	{
		timerinited = 0;

}
}
void ExtCleanUp(void)
{
}

void ExtLoadMap(const char *mapname)
{
}


const char *ExtGetSectorCaption(short sectnum)
{
        if ((sector[sectnum].lotag|sector[sectnum].hitag) == 0)
	{
		tempbuf[0] = 0;
	}
	else
	{
                sprintf(tempbuf,"%hu,%hu",(unsigned short)sector[sectnum].hitag,
										  (unsigned short)sector[sectnum].lotag);
	}
	return(tempbuf);
}

const char *ExtGetWallCaption(short wallnum)
{

        if ((wall[wallnum].cstat&16) && ((wall[wallnum].lotag|wall[wallnum].hitag) == 0) > 0)
        {
                sprintf(tempbuf,"MASKED");
                                         
	}

        else if ((wall[wallnum].cstat&32) && ((wall[wallnum].lotag|wall[wallnum].hitag) == 0) > 0)
        {
                sprintf(tempbuf,"MASKED");
                                         
	}

        else if ((wall[wallnum].cstat&16) && ((wall[wallnum].lotag|wall[wallnum].hitag) > 0) > 0)
        {
                sprintf(tempbuf,"%hu,%hu MASKED",(unsigned short)wall[wallnum].hitag,(unsigned short)wall[wallnum].lotag);
                                         
	}

        else if ((wall[wallnum].cstat&32) && ((wall[wallnum].lotag|wall[wallnum].hitag) > 0) > 0)
        {
                sprintf(tempbuf,"%hu,%hu MASKED",(unsigned short)wall[wallnum].hitag,(unsigned short)wall[wallnum].lotag);
                                         
	}



        else if ((wall[wallnum].lotag|wall[wallnum].hitag) > 0)

        {
		sprintf(tempbuf,"%hu,%hu",(unsigned short)wall[wallnum].hitag,
										  (unsigned short)wall[wallnum].lotag);
	}
        else 
	{
		tempbuf[0] = 0;
	}


	return(tempbuf);
}

const char *ExtGetSpriteCaption(short spritenum)
{
        if ((sprite[spritenum].lotag|sprite[spritenum].hitag) == 0)
	{
                tempbuf[0] = 0;
	}
	else
	{


                sprintf(tempbuf,"%hu,%hu %s",(unsigned short)sprite[spritenum].hitag,
                                                                                  (unsigned short)sprite[spritenum].lotag,names[sprite[spritenum].picnum]);
                
	}
       


        return(tempbuf);
}

//printext16 parameters:
//printext16(long xpos, long ypos, short col, short backcol,
//           char name[82], char fontsize)
//  xpos 0-639   (top left)
//  ypos 0-479   (top left)
//  col 0-15
//  backcol 0-15, -1 is transparent background
//  name
//  fontsize 0=8*8, 1=3*5

//drawline16 parameters:
// drawline16(long x1, long y1, long x2, long y2, char col)
//  x1, x2  0-639
//  y1, y2  0-143  (status bar is 144 high, origin is top-left of STATUS BAR)
//  col     0-15

void ExtShowSectorData(short sectnum)   //F5
{
	if (qsetmode == 200)    //In 3D mode
	{
	}
	else
	{
		clearmidstatbar16();             //Clear middle of status bar

        sprintf(tempbuf,"Sector %d",sectnum);

        printext16(8,32,commaeleven,-1,tempbuf,0);

        sprintf(tempbuf,"Firstwall: %d",sector[sectnum].wallptr);

        printext16(8,48,commaeleven,-1,tempbuf,0);

        sprintf(tempbuf,"Numberofwalls: %d",sector[sectnum].wallnum);

        printext16(8,56,commaeleven,-1,tempbuf,0);
  
        sprintf(tempbuf,"Firstsprite: %d",headspritesect[sectnum]);

        printext16(8,64,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Tags: %ld, %ld",sector[sectnum].hitag,sector[sectnum].lotag);

        printext16(8,72,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"     (0x%x), (0x%x)",sector[sectnum].hitag,sector[sectnum].lotag);

        printext16(8,80,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Extra: %ld",sector[sectnum].extra);

        printext16(8,88,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Visibility: %ld",sector[sectnum].visibility);

        printext16(8,96,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Pixel height: %ld",(sector[sectnum].floorz-sector[sectnum].ceilingz)>>8);
        printext16(8,104,commaeleven,-1,tempbuf,0);

        printext16(200,32,commaeleven,-1,"CEILINGS:",0);
        sprintf(tempbuf,"Flags (hex): %x",sector[sectnum].ceilingstat);
        printext16(200,48,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"(X,Y)pan: %d, %d",sector[sectnum].ceilingxpanning,sector[sectnum].ceilingypanning);
        printext16(200,56,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Shade byte: %d",sector[sectnum].ceilingshade);
        printext16(200,64,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Z-coordinate: %ld",sector[sectnum].ceilingz);
        printext16(200,72,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Tile number: %d",sector[sectnum].ceilingpicnum);
        printext16(200,80,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Ceiling heinum: %d",sector[sectnum].ceilingheinum);
        printext16(200,88,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Palookup number: %d",sector[sectnum].ceilingpal);
        printext16(200,96,commaeleven,-1,tempbuf,0);

        printext16(400,32,commaeleven,-1,"FLOORS:",0);
        sprintf(tempbuf,"Flags (hex): %x",sector[sectnum].floorstat);
        printext16(400,48,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"(X,Y)pan: %d, %d",sector[sectnum].floorxpanning,sector[sectnum].floorypanning);
        printext16(400,56,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Shade byte: %d",sector[sectnum].floorshade);
        printext16(400,64,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Z-coordinate: %ld",sector[sectnum].floorz);
        printext16(400,72,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Tile number: %d",sector[sectnum].floorpicnum);
        printext16(400,80,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Floor heinum: %d",sector[sectnum].floorheinum);
        printext16(400,88,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Palookup number: %d",sector[sectnum].floorpal);
        printext16(400,96,commaeleven,-1,tempbuf,0);



        }
}

void ExtShowWallData(short wallnum)       //F6
{
        long dax, day, dist;
        long i;
        if (qsetmode == 200)    //In 3D mode
	{
	}
	else
	{
		clearmidstatbar16();             //Clear middle of status bar

//        sprintf(tempbuf,"Wall %d length: %d",wallnum,dist>>4);

        

        sprintf(tempbuf,"Wall %d",wallnum);
        printext16(8,32,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"X-coordinate: %ld",wall[wallnum].x);
        printext16(8,48,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Y-coordinate: %ld",wall[wallnum].y);
        printext16(8,56,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Point2: %d",wall[wallnum].point2);
        printext16(8,64,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Sector: %d",sectorofwall(wallnum));
        printext16(8,72,commaeleven,-1,tempbuf,0);

        sprintf(tempbuf,"Tags: %ld, %ld",wall[wallnum].hitag,wall[wallnum].lotag);
        printext16(8,88,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"     (0x%x), (0x%x)",wall[wallnum].hitag,wall[wallnum].lotag);
        printext16(8,96,commaeleven,-1,tempbuf,0);


        sprintf(tempbuf,"Flags (hex): %x",wall[wallnum].cstat);
        printext16(200,48,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Shade: %d",wall[wallnum].shade);
        printext16(200,56,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Pal: %d",wall[wallnum].pal);
        printext16(200,64,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"(X,Y)repeat: %d, %d",wall[wallnum].xrepeat,wall[wallnum].yrepeat);
        printext16(200,72,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"(X,Y)pan: %d, %d",wall[wallnum].xpanning,wall[wallnum].ypanning);
        printext16(200,80,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Tile number: %d",wall[wallnum].picnum);
        printext16(200,88,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"OverTile number: %d",wall[wallnum].overpicnum);
        printext16(200,96,commaeleven,-1,tempbuf,0);

        sprintf(tempbuf,"nextsector: %d",wall[wallnum].nextsector);
        printext16(400,48,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"nextwall: %d",wall[wallnum].nextwall);
        printext16(400,56,commaeleven,-1,tempbuf,0);

        sprintf(tempbuf,"Extra: %d",wall[wallnum].extra);
        printext16(400,72,commaeleven,-1,tempbuf,0);

	dax = wall[wallnum].x-wall[wall[wallnum].point2].x;
	day = wall[wallnum].y-wall[wall[wallnum].point2].y;
	dist = ksqrt(dax*dax+day*day);
        sprintf(tempbuf,"Wall length: %d",dist>>4);
        printext16(400,96,commaeleven,-1,tempbuf,0);

//        dax = (long)sectorofwall(wallnum);
//        sprintf(tempbuf,"Pixel height: %ld",(sector[dax].floorz-sector[dax].ceilingz)>>8);
//        printext16(400,104,commaeleven,-1,tempbuf,0);



//                printext16(8,32,commaeleven,-1,tempbuf,0);
	}
}

void ExtShowSpriteData(short spritenum)   //F6
{
	if (qsetmode == 200)    //In 3D mode
	{
	}
	else
	{
		clearmidstatbar16();             //Clear middle of status bar

        sprintf(tempbuf,"Sprite %d",spritenum);
        printext16(8,32,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"X-coordinate: %ld",sprite[spritenum].x);
        printext16(8,48,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Y-coordinate: %ld",sprite[spritenum].y);
        printext16(8,56,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Z-coordinate: %ld",sprite[spritenum].z);
        printext16(8,64,commaeleven,-1,tempbuf,0);

        sprintf(tempbuf,"Sectnum: %d",sprite[spritenum].sectnum);
        printext16(8,72,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Statnum: %d",sprite[spritenum].statnum);
        printext16(8,80,commaeleven,-1,tempbuf,0);

        sprintf(tempbuf,"Tags: %ld, %ld",sprite[spritenum].hitag,sprite[spritenum].lotag);
        printext16(8,96,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"     (0x%x), (0x%x)",sprite[spritenum].hitag,sprite[spritenum].lotag);
        printext16(8,104,commaeleven,-1,tempbuf,0);

        sprintf(tempbuf,"Flags (hex): %x",sprite[spritenum].cstat);
        printext16(200,48,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Shade: %d",sprite[spritenum].shade);
        printext16(200,56,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Pal: %d",sprite[spritenum].pal);
        printext16(200,64,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"(X,Y)repeat: %d, %d",sprite[spritenum].xrepeat,sprite[spritenum].yrepeat);
        printext16(200,72,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"(X,Y)offset: %d, %d",sprite[spritenum].xoffset,sprite[spritenum].yoffset);
        printext16(200,80,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Tile number: %d",sprite[spritenum].picnum);
        printext16(200,88,commaeleven,-1,tempbuf,0);

        sprintf(tempbuf,"Angle (2048 degrees): %d",sprite[spritenum].ang);
        printext16(400,48,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"X-Velocity: %d",sprite[spritenum].xvel);
        printext16(400,56,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Y-Velocity: %d",sprite[spritenum].yvel);
        printext16(400,64,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Z-Velocity: %d",sprite[spritenum].zvel);
        printext16(400,72,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Owner: %d",sprite[spritenum].owner);
        printext16(400,80,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Clipdist: %d",sprite[spritenum].clipdist);
        printext16(400,88,commaeleven,-1,tempbuf,0);
        sprintf(tempbuf,"Extra: %d",sprite[spritenum].extra);
        printext16(400,96,commaeleven,-1,tempbuf,0);

//                sprintf(tempbuf,"Sprite %d",spritenum);
//                printext16(8,32,commaeleven,-1,tempbuf,0);
	}
}

void ExtEditSectorData(short sectnum)    //F7
{

        short bad;

        if (qsetmode == 200)    //In 3D mode
	{
	}
	else                    //In 2D mode
	{
        showsectordata(sectnum);
        }

}

void ExtEditWallData(short wallnum)       //F8
{
	short nickdata;

	if (qsetmode == 200)    //In 3D mode
	{
	}
	else
	{
		sprintf(tempbuf,"Wall (%ld) Nick's variable: ",wallnum);
		nickdata = 0;
		nickdata = getnumber16(tempbuf,nickdata,65536L);

		printmessage16("");              //Clear message box (top right of status bar)
		ExtShowWallData(wallnum);
	}
}

void ExtEditSpriteData(short spritenum)   //F8
{
	short nickdata;

	if (qsetmode == 200)    //In 3D mode
	{
	}
	else
	{
		sprintf(tempbuf,"Sprite (%ld) Nick's variable: ",spritenum);
		nickdata = 0;
		nickdata = getnumber16(tempbuf,nickdata,65536L);
		printmessage16("");

		printmessage16("");              //Clear message box (top right of status bar)
		ExtShowSpriteData(spritenum);
	}
}

faketimerhandler()
{
}

	//Just thought you might want my getnumber16 code
/*
getnumber16(char namestart[80], short num, long maxnumber)
{
	char buffer[80];
	long j, k, n, danum, oldnum;

	danum = (long)num;
	oldnum = danum;
	while ((keystatus[0x1c] != 2) && (keystatus[0x1] == 0))  //Enter, ESC
	{
		sprintf(&buffer,"%s%ld_ ",namestart,danum);
		printmessage16(buffer);

		for(j=2;j<=11;j++)                //Scan numbers 0-9
			if (keystatus[j] > 0)
			{
				keystatus[j] = 0;
				k = j-1;
				if (k == 10) k = 0;
				n = (danum*10)+k;
				if (n < maxnumber) danum = n;
			}
		if (keystatus[0xe] > 0)    // backspace
		{
			danum /= 10;
			keystatus[0xe] = 0;
		}
		if (keystatus[0x1c] == 1)   //L. enter
		{
			oldnum = danum;
			keystatus[0x1c] = 2;
			asksave = 1;
		}
	}
	keystatus[0x1c] = 0;
	keystatus[0x1] = 0;
	return((short)oldnum);
}
*/
